/*
 * Camera.java
 *
 * Created on Piatok, 2004, november 5, 17:12
 */

package graphics.math;

/**
 *
 * @author  Marek Mizanin
 */
public class Camera
{	
	public v vp = new v();		// View position			- pozicia pohladu (o?)
	public v vp_old = new v();	// View position old		- pozicia pohladu (o?) v predchadzajucom snimku, pouzitie pre detekciu kolizie
	public v vd = new v();		// View direction vector	- smerovy vektor
	public v vu = new v();		// View up direction		- vektor zmerujuci hore - normalovy vektor hornej plochy kamery
	public v vr = new v();		// View right direction		- vektor smerujuci vpravo
	public v vcp = new v();		// View central point
	public float vpd;			// View point delta
	final float MOUSE_SPEED=0.5f;
	
	public Camera()
	{
		reset();
	}
	public void reset()
	{
		vd.set(0,0,-1);
		vr.set(1,0,0); 
		vu.set(0,1,0);
		vcp.set(0,0,0);
		vpd = 15.f;
		vp.set(v.sub(vcp,v.mul(vd,vpd)));	// vp = vcp - vd*vpd;
		vp_old.set(vp);
	}
	public void moveWorld(float mdx, float mdy, boolean left, boolean right)
	{
		float rot_x=0,rot_y=0,rot_z=0;		// rotate
		float trn_x=0,trn_y=0,trn_z=0;		// translate x, y, z
		
		if(left && right)
		{
			trn_x += 0.1f*MOUSE_SPEED*mdx;
			trn_y -= 0.1f*MOUSE_SPEED*mdy;
		}
		else if(left)
		{
			rot_y -= MOUSE_SPEED*mdx;
			rot_x -= MOUSE_SPEED*mdy;
		}
		else if(right)
		{
			trn_z -= 0.1f*MOUSE_SPEED*mdy;	
		}
	//	if(trn_x==0 && trn_y==0 && trn_z==0 && rot_x==0 && rot_y==0 && rot_z==0) return;

		mat m = new mat();
		m.MakeMatrix( vr, vu, v.neg(vd));
		m.Translate( v.sub(vcp,vp));
		v o = m.mul(v.add(v.mul(trn_x,vr), v.add(v.mul(trn_y,vu),v.mul(trn_z,vd))));
		
		walkRotate( rot_x, rot_y, rot_z);

		m.Identity();
		m.MakeMatrix( vr, vu, v.neg(vd));
		m = mat.Transpose(m);
		vp.set(m.mul(v.neg(o)));
		vp.add(vcp);
		
		
	/*	// posun stredu vcp += trn_x*vr + trn_y*vu + trn_z*vd;    // posunutie bodu vcp
		vcp.add(v.mul(trn_x,vr));
		vcp.add(v.mul(trn_y,vu));
		vcp.add(v.mul(trn_z,vd));
		
		walkRotate( rot_x, rot_y, rot_z);
		vp.set(v.sub(vcp,v.mul(vd,vpd)));  // vp = vcp - vd*vpd; ked rotujeme okolo bodu vcp
	 */
	}
	
	// WalkRotate - rotacia, ktora sa vyuziva pri chodeni (walk) v bludisku
	// pri tejto rotacii sa rotuje vzdy okolu osi y t.j. v pripade ze sa pozerame prave v smere
	// osi y (hore, alebo dole) tak sa scena otaca okolo vlastnej osi (neposuva sa vpravo alebo vlavo)
	void walkRotate(float x, float y, float z)	// rotacie
	{
		// x > 0 kamera sa toci hore
		// x < 0				dole
		// y > 0 kamera sa toci doprava
		// y < 0				dolava

		// rotacia okolo osi y
		vd.RotY( y);
		vr.RotY( y);
		vu.RotY( y);

		// rotacia okolo osi x, t.j. okolo vektora vr

		// vd sa nesmie dostat za 0,1,0 alebo, 0,-1,0
		v vd_ = new v(vd);

		// rotacia vektora vd okolo vektora vr o uhol x
		vd_.ArbitraryRotate( x, vr);
		// ak je vd pred 0,1,0 a vd_ je za je zle, treba otocit tak aby vd = 0,1,0
		// ak je vd pred a vd_ za tak maju pri rovnakych suradniciach rozne znamienka
		// ak je vd a vd_ na tej istej strane maju rovnake znamienka

		if(vd_.x*vd.x<0 || vd_.z*vd.z<0)	// jeden je na jednej strane druhy je uz za
		{
			float angle=1;
			if(vd_.y<0)angle=-1;			// ak pozerame dole tak budeme rotovat dole
			if(vd_.y>0)vd_.set(0,1,0);		// ak vektor smeruje hore nastavyme ho na 0, 1,0
			else vd_.set(0,-1,0);			// ak vektor smeruje dole nastavyme ho na 0,-1,0
			angle *= (float)Math.acos( v.DOT3(vd_,vd));	// uhol medzi starym vd a novym vd_
			vu.ArbitraryRotate( angle/v.PI180, vr);	// rotujeme vu
			vd.set(vd_);						// aktualny vd je vd_
		}
		else								// vd a vd_ su na tej istej strane
		{
			// ak vd.y==1 a x>0, smer rotacie je taky, ze ak by sme rotovali presli by sme na duhu stranu
			// ak vd.y==-1 a x<0,smer rotacie je taky, ze ak by sme rotovali presli by sme na duhu stranu
			// tieto pripady osetrime tak, ze vd a vr nebudeme vobec rotavat, v ostatnych pripadoch rotovat budeme
			if( !(vd.y==1 && x>0) && !(vd.y==-1 && x<0) )
			{
				vd.ArbitraryRotate( x, vr);
				vu.ArbitraryRotate( x, vr);
			}
		}
		vd.Normalize();
		vr.Normalize();
		vu.Normalize();	
	}
	public mat getMatrix()
	{
		mat m = new mat();
		m.MakeMatrix( vr, vu, v.neg(vd));
		m.Translate( v.neg(vp));
		return m;
	}
	public String toString()
	{
		return 
		( "vp: "+vp.toString()+
		"\nvd: "+vd.toString()+
		"\nvu: "+vu.toString()+
		"\nvr: "+vr.toString()+
		"\nvcp: "+vcp.toString()+
		"\nvpd: "+Float.toString(vpd));
	}
	public String[] toStringA()
	{
		String s[] = new String[6];
		s[0] = "vp: "+vp.toString();
		s[1] = "\nvd: "+vd.toString();
		s[2] = "\nvu: "+vu.toString();
		s[3] = "\nvr: "+vr.toString();
		s[4] = "\nvcp: "+vcp.toString();
		s[5] = "\nvpd: "+Float.toString(vpd);
		return s;
	}
	
}
