/*
 * Lsystem.java
 *
 * Created on Streda, 2004, oktber 20, 16:25
 */
package lsystem;
import lsystem.generovanie.*;
import lsystem.korytnacka.*;
import java.util.*;
import java.lang.*;
import graphics.math.*;
/**
 *
 * @author  Marek Mizanin
 */

public class Lsystem extends Lsystem_text
{
	public Koryt k;					// aktualna korytnacka, pouziva sa vo funkcii Vytvor(velkost);
	public Koryt kk;				// aktualna korytnacka pre vykreslovanie, tato sa moze externe menit	
	public Koryt_Line kLine;		// kresli ciary
	public Koryt_Valce kValce;		// kresli valce
	public KorytMinMax kminmax;		// korytnacka pre zistenie minima a maxima pri pociatocnej dlzke 1
	public v stred = new v();
	Lsystem_setting s;
	int akt_material,akt_back_material;
	public boolean pouzi_hom=true;
	public Lsystem()
	{
		super();
		s = new Lsystem_setting();
		kLine = new Koryt_Line();
		kminmax = new KorytMinMax();
		kValce = new Koryt_Valce();
		k = kminmax;
		k.Reset();
	//	kk = kLine;
		kk = kValce;
	//	r.delete(0, r.length());
	//	r.append("F[+F][-F][^F][&F][+F[+F][-F][^F][&F]][-F[+F][-F][^F][&F]][^F[+F][-F][^F][&F]][&F[+F][-F][^F][&F]]");
	//	r = "F[+F][-F][^F][&F][+F[+F][-F][^F][&F]][-F[+F][-F][^F][&F]][^F[+F][-F][^F][&F]][&F[+F][-F][^F][&F]][+F[+F][-F][^F][&F][+F[+F][-F][^F][&F]][-F[+F][-F][^F][&F]][^F[+F][-F][^F][&F]][&F[+F][-F][^F][&F]]][-F[+F][-F][^F][&F][+F[+F][-F][^F][&F]][-F[+F][-F][^F][&F]][^F[+F][-F][^F][&F]][&F[+F][-F][^F][&F]]][^F[+F][-F][^F][&F][+F[+F][-F][^F][&F]][-F[+F][-F][^F][&F]][^F[+F][-F][^F][&F]][&F[+F][-F][^F][&F]]][&F[+F][-F][^F][&F][+F[+F][-F][^F][&F]][-F[+F][-F][^F][&F]][^F[+F][-F][^F][&F]][&F[+F][-F][^F][&F]]]";
	}
	public void Ciary() { kk.Reset(); kk = kLine; Vytvor();}
	public void Valce() { kk.Reset(); kk = kValce; Vytvor();}
    
	public void Vytvor()
	{
		k = kminmax;				// za akt. zoberieme korytnacku pre zistenie max a min
		Vytvor(1.0f);				// prejdeme cely retazec, premenne max a min sa nastavia
		float maxim=1;				// maxim bude obsahovat najvacsiu hodnotu z najvacsej sirky, vysky a hlbky
		if(kminmax.max.x-kminmax.min.x>maxim)maxim=kminmax.max.x-kminmax.min.x;	// sirka
		if(kminmax.max.y-kminmax.min.y>maxim)maxim=kminmax.max.y-kminmax.min.y;	// vyska
		if(kminmax.max.z-kminmax.min.z>maxim)maxim=kminmax.max.z-kminmax.min.z;	// hlbka

		k = kk;
		stred.set(v.mul(0.5f,v.add(kminmax.max,kminmax.min)));		// vypocet stredu objektu
		maxim = 10.f/maxim;				// nastavime dlzku na taku aby objekt mal maximalny rozmer velkosti 10
		stred.mul(maxim);					// presunieme novy stred
		Vytvor( maxim);
	}
    
    public int NacitajParametre(StringBuffer retazec, Vector par, int j)		// j ukazuje na otvaraciu zatvorku '('
    {
        Vector a=null;
        Vector b=null;
        String s;
        do
        {					// j ukazuje na zatvaraciu zatvorku, alebo ciarku
            j++;			// j ukazuje za zatvaraciu zatvorku, alebo ciarku
            s = new String();
            while(retazec.charAt(j)!=')' && retazec.charAt(j)!=',')	// pokial nie je koniec zatvorky, alebo ciarka
            {
                s+=retazec.charAt(j);		// pridavame znaky
                j++;
            }
				// j ukazuje na zatvaraciu zatvorku, alebo ciarku
            //(*par).push_back((float)atof( s.c_str()));
           // Float parameter = new Float(Vycisli_premennu(s,a,b));
			Float parameter = new Float(Float.parseFloat(s));
            par.addElement(parameter);
        }
        while(retazec.charAt(j)!=')');		// j ukazuje na zatvaraciu zatvorku
        return j;	// je ukazuje na ')'
    }
    
	public void Vytvor(float velkost)
    {
        // *retazec musi mat v okruhlich zatvorkach iba cisla a musi byt v okruhlich zatvorkach poriadok, inak program moze spadnut
        StringBuffer retazec = new StringBuffer();
        int	dlzka=1;		// specifikuje dlzku ked sa najde @, dlzka je vratane @, dlzka umoznuje rozlisit @c od @c1
	
        if(prod_hom.size()>0 && pouzi_hom) retazec = rh;
        else retazec = r;
		
        int length = retazec.length();	// dlzka
        int j=0;
        Vector par = new Vector();			// vektor parametrov
        int hran_zat = 0;				// aktualny pocet hranatych zatvoriek

        k.Reset();
        k.stav.clear();
        k.stav.kontura = s.kruh;
        akt_material = s.initial_material;
        akt_back_material = s.initial_material_back;
        k.stav.mat = s.mat(akt_material);
        if(akt_back_material>=0) k.stav.mat_back = s.mat(akt_back_material);
		if(kk==kValce)
			k.stav.color = 0x00ff00;
		
        k.stav.dlzka = velkost;
    //	k->stav.uhol = s.angle;
        k.stav.uhol = angle;
        k.twist_of_cylinders = s.twist_of_cylinders;
        k.prisposob_sirku = s.prisposob_sirku;
   /*     if(k==valce)
            valce.Vypocitaj_body_na_guli(s.delenie_gule+1, s.delenie_gule);
        else if(k==kLine)
            kLine.Vypocitaj_body_na_guli(s.delenie_gule+1, s.delenie_gule);*/

        par.clear();
        for(int i=0; i<length; i++)		// cez cely zdrojovy retazec
        {
            par.clear();
            if(i+1<length)
            {
                if(retazec.charAt(i+1)=='(') {j = NacitajParametre(retazec, par, i+1);}
                else if(retazec.charAt(i)=='@')
                {
                    char ch1 = retazec.charAt(i+1);
                    switch(retazec.charAt(i+1))
                    {
                    case 'O':
                        dlzka=2;
                        if(i+2<length)
                        {
                            if(retazec.charAt(i+2)=='1' || retazec.charAt(i+2)=='2')
                            {
                                dlzka=3;
                                if(i+3<length)
                                {
                                    if(retazec.charAt(i+3)=='(') {j = NacitajParametre(retazec, par, i+3);}
                                }
                            }
                            else if(retazec.charAt(i+2)=='(') {j = NacitajParametre(retazec, par, i+2);}
                        }
                        break;
                    case 'c':
                        dlzka=2;
                        if(i+2<length)
                        {
                            if(retazec.charAt(i+2)=='1' || retazec.charAt(i+2)=='2')
                            {
                                dlzka=3;
                                if(i+3<length)
                                {
                                    if(retazec.charAt(i+3)=='(') {j = NacitajParametre(retazec, par, i+3);}
                                }
                            }
                            else if(retazec.charAt(i+2)=='(') {j = NacitajParametre(retazec, par, i+2);}
                        }
                        break;
                    case '#':
                        dlzka=2;
                        if(i+2<length)
                        {
                            if(retazec.charAt(i+2)=='(') {j = NacitajParametre(retazec, par, i+2);}
                        }
                        break;
                    case 'G':
                        dlzka=2;
                        if(i+2<length)
                        {
                            char ch=retazec.charAt(i+2);
                            if(ch=='s' || ch=='c' || ch=='e' || ch=='t' || ch=='r')
                            {
                                dlzka=3;
                                if(i+3<length)
                                {
                                    if(retazec.charAt(i+3)=='(') {j = NacitajParametre(retazec, par, i+3);}
                                }
                            }
                        }
                        break;
                    case ';':
                        dlzka=2;
                        if(i+2<length)
                        {
                            if(retazec.charAt(i+2)=='(') {j = NacitajParametre(retazec, par, i+2);}
                        }
                        break;
                    case ',':
                        dlzka=2;
                        if(i+2<length)
                        {
                            if(retazec.charAt(i+2)=='(') {j = NacitajParametre(retazec, par, i+2);}
                        }
                        break;
                    case 'T':
                        dlzka=2;
                        if(i+2<length)
                        {
                            if(retazec.charAt(i+2)=='x')
                            {
                                dlzka=3;
                                if(i+3<length)
                                {
                                    if(retazec.charAt(i+3)=='(') {j = NacitajParametre(retazec, par, i+3);}
                                }
                            }
                        }
                        break;
                    }
                }
            }
            if(par.size()>0)		// ak su parametre
            {
                switch(retazec.charAt(i))
                {
                case 'F':
                    if(par.size()==1) k.F(((Float)par.get(0)).floatValue());
                    else if(par.size()==2) k.F(((Float)par.get(0)).floatValue(),((Float)par.get(1)).floatValue());
                    break;
                case 'f': k.f(((Float)par.get(0)).floatValue()); break;
                //	case 'E': if(e_je_to_iste_ako_f) k->F( par[0]); break;
                //	case 'e': if(e_je_to_iste_ako_f) k->f( par[0]); break;
                case 'G': k.G(((Float)par.get(0)).floatValue()); break;
                case 'g': k.g(((Float)par.get(0)).floatValue()); break;
                case '+': k.plus(((Float)par.get(0)).floatValue()); break;
                case '-': k.minus(((Float)par.get(0)).floatValue()); break;
                case '^': k.xor(((Float)par.get(0)).floatValue()); break;
                case '&': k.and(((Float)par.get(0)).floatValue()); break;
                case '/': k.del(((Float)par.get(0)).floatValue()); break;
                case '\\':k.odel(((Float)par.get(0)).floatValue()); break;
                case '|': break;			// chyba
                case '$': break;			// chyba
                case '[': break;			// chyba
                case ']': break;			// chyba
                case '{': break;			// chyba
                case '}': break;			// chyba
                case '.': break;			// chyba
                case ':': 
                	if(par.size()==3)
						k.dvoj_bodka(((Float)par.get(0)).floatValue(),((Float)par.get(1)).floatValue(),((Float)par.get(2)).floatValue());
                //	else	// chyba
				break;
                case ';': 
					if(par.size()==3)
						k.dvoj_bodka(((Float)par.get(0)).floatValue(),((Float)par.get(1)).floatValue(),((Float)par.get(2)).floatValue());
					else
						ZmenMaterial(((Float)par.get(0)).floatValue(),0); break;
                case ',': 
					if(par.size()==3)
						k.dvoj_bodka(((Float)par.get(0)).floatValue(),((Float)par.get(1)).floatValue(),((Float)par.get(2)).floatValue());
					else
						ZmenMaterial(((Float)par.get(0)).floatValue(),0); break;
                case '\'': k.uvodzovka(((Float)par.get(0)).floatValue()); break;
                case '\"': k.uvodzovka_dvojita(((Float)par.get(0)).floatValue()); break;
                case '!': k.vykricnik(((Float)par.get(0)).floatValue()); break;
                case '#': k.mriezka(((Float)par.get(0)).floatValue()); break;
                case '%': break;			// chyba
                case '@':
                    {
                        if(dlzka==1) break;
                        else if(dlzka==2)
                        {
                            if(retazec.charAt(i+1)=='O') k.zO(((Float)par.get(0)).floatValue());
                            else if(retazec.charAt(i+1)=='#')
                            {
                                int id_kon=((Float)par.get(0)).intValue();
                            //	k->z_mriezka();
                            //	k->Dokonci();
//                                k.stav.kontura=s.kruh;
//                                for(int kon=0; kon<s.kontury.size(); kon++)
//                                {
//                                    if(s.kontury[kon].id==id_kon) k.stav.kontura=s.kontury[kon];
//                                }
                            }
                            else if(retazec.charAt(i+1)==';') ZmenBackMaterial(((Float)par.get(0)).floatValue(),0);
                            else if(retazec.charAt(i+1)==',') ZmenBackMaterial(((Float)par.get(0)).floatValue(),0);
                            i++;
                        }
                        else if(dlzka==3)
                        {
                            switch(retazec.charAt(i+1))
                            {
                            case 'O':
                                if(retazec.charAt(i+2)=='1') k.zO1(((Float)par.get(0)).floatValue());
                                else if(retazec.charAt(i+2)=='2') k.zO2(((Float)par.get(0)).floatValue());
                                break;
                            case 'c':
                                if(retazec.charAt(i+2)=='1') k.zc1(((Float)par.get(0)).floatValue());
                                else if(retazec.charAt(i+2)=='2') k.zc2(((Float)par.get(0)).floatValue());
                                break;
                            case 'G':
                                switch(retazec.charAt(i+2))
                                {
                                case 's': break;	// chyba
                                case 'c': k.zGc(((Float)par.get(0)).intValue()); break;
                                case 'e': k.zGe(((Float)par.get(0)).intValue()); break;
                                case 't': if(par.size()==2) k.zGt(((Float)par.get(0)).floatValue(),((Float)par.get(1)).floatValue()); break;
                                case 'r': 
                                    if(par.size()==1) k.zGr(((Float)par.get(0)).intValue());
                                    if(par.size()==4) k.zGr(((Float)par.get(0)).floatValue(),((Float)par.get(1)).floatValue(),((Float)par.get(2)).floatValue(),((Float)par.get(3)).floatValue());
                                    break;
                                }
                                break;
                 /*           case 'T':
                                if(retazec.charAt(i+2)=='x' && par.size()!=0)
                                {
                                    int tindex = ((Float)par.get(0)).intValue();
									k.stav.texture_id = 0;
                                    for(int it=0; it<s.tex.size(); it++)
                                    {
                                        if(s.tex[it].index==tindex)
                                        {
                                            k.stav.texture_id = s.tex[it].id;
                                            k.stav.texture_env = s.tex[it].env;
                                            k.stav.t_mierka = s.tex[it].ratio;
                                            k.stav.t_posun = s.tex[it].move;
                                        }
                                    }
                                }
                                break;*/
                            }
                            i+=2;
                        }
                        break;
                    }
                default: ;					// chyba
                }
                i=j;				// j ukazuje na ')', i po zvyseni bude ukazovat na dalsi znak po ')'
            }
            else					// ak nie su parametre
            {
                switch(retazec.charAt(i))
                {
                case 'F': k.F(); break;
                case 'f': k.f(); break;
            //	case 'E': if(e_je_to_iste_ako_f) k->F(); break;
            //	case 'e': if(e_je_to_iste_ako_f) k->f(); break;
                case 'G': k.G(); break;
                case 'g': k.g(); break;
                case '+': k.plus(); break;
                case '-': k.minus(); break;
                case '^': k.xor(); break;
                case '&': k.and(); break;
                case '/': k.del(); break;
                case '\\':k.odel(); break;
                case '|': k.or(); break;
                case '$': k.dolar(); break;
                case '[': k.zat_hran_otv(); hran_zat++; break;
                case ']': if(hran_zat>0) {k.zat_hran_zat(); hran_zat--;} break;
                case '{': k.zat_zloz_otv(); break;
                case '}': k.zat_zloz_zat(); break;
                case '.': k.bodka(); break;
                case ':': break;		// chyba
                case ';': ZmenMaterial( 0, 1); break;
                case ',': ZmenMaterial( 0,-1); break;
                case '\'': k.uvodzovka(); break;
                case '\"': k.uvodzovka_dvojita(); break;
                case '!': k.vykricnik(); break;
                case '#': k.mriezka(); break;
                case '%':
                    if(hran_zat>0)			// ak sme vnutry hranatych zatvoriek
                    {
                        int zat = 0,q;
                        for(q=i+1; q<length; q++)	// zaciname za znakom %
                        {
                            if(retazec.charAt(q)=='[') zat++;	// zvysime pocitadlo vnutornych zatvoriek
                            else if(retazec.charAt(q)==']')	// nasla sa uzatvaracia zatvorka
                            {
                                if(zat==0)break;	// ak je pocet vnutornych zatvoriek je OK, ukoncime
                                else zat--;			// inak znizime pocitadlo vnutornych zatvoriek
                            }
                        }
                            // q ukazuje na ']' zatvorku parovu k poslednej '['
                        i = q-1;	// i ukazuje na znak pred ']', ale po zvysenie bude ukazovat na ']'
                    }
                //	else	i = length;	// ukoncime prehladavanie retazca
                    break;
                case '@':
                    {
                        if(dlzka==1)break;
                        else if(dlzka==2)
                        {
                            if(retazec.charAt(i+1)=='O') k.zO();
                            else if(retazec.charAt(i+1)=='#')
                            {
                            //	k->z_mriezka();
                            //	k->Dokonci();
//                                k.stav.kontura=s.kruh;
                            }
                            else if(retazec.charAt(i+1)==';') ZmenBackMaterial(0, 1);
                            else if(retazec.charAt(i+1)==',') ZmenBackMaterial(0,-1);
                            i++;
                        }
                        else if(dlzka==3)
                        {
                            switch(retazec.charAt(i+1))
                            {
                            case 'O':
                                if(retazec.charAt(i+2)=='1') k.zO1();
                                else if(retazec.charAt(i+2)=='2') k.zO2();
                                break;
                            case 'c':
                                if(retazec.charAt(i+2)=='1') k.zc1();
                                else if(retazec.charAt(i+2)=='2')k.zc2();
                                break;
                            case 'G':
                                switch(retazec.charAt(i+2))
                                {
                                case 's': k.zGs(); break;
                                case 'c': k.zGc(); break;
                                case 'e': k.zGe(); break;
                                case 't': k.zGt(); break;
                                case 'r': k.zGr(); break;
                                }
                                break;
                       /*     case 'T':
                                if(retazec.charAt(i+2)=='x') k.stav.texture_id = 0;
                                break;*/
                            }
                            i+=2;
                        }
                        break;
                    }
                default: ;				// chyba
                }
            }
        }
        k.Koncove_vypocty();
//        k.stavclear();
    }
	public void ZmenMaterial(float n, int add)
	{
		if( add!=0)
			akt_material += add;
		else
			akt_material = (int)Math.floor(n+0.01f);
		if(akt_material<0)akt_material=s.mat.size()-1;
		akt_material %= s.mat.size();
		k.stav.mat = s.mat(akt_material);
		k.stav.color = k.stav.mat.diffuse;
	}
	public void ZmenBackMaterial(float n, int add)
	{
		if( add!=0)
			akt_back_material += add;
		else
			akt_back_material = (int)Math.floor(n+0.01f);
		if(akt_back_material<0)akt_back_material=s.mat.size()-1;
		akt_back_material %= s.mat.size();
		k.stav.mat_back = s.mat(akt_back_material);
	}
}
