/*
 * Lsystem_setting.java
 *
 * Created on Sobota, 2004, november 6, 18:10
 */

package lsystem;
import lsystem.generovanie.*;
import lsystem.korytnacka.*;
import java.util.*;
import java.lang.*;
import graphics.math.*;
import graphics.device.*;
/**
 *
 * @author  Marek Mizanin
 */
public class Lsystem_setting
{
	// vseobecne
//	float	angle;			// default uhol pre korytnacku,				90
							// angle factor: x		angle = 360/x
							// angle increment: x	angle = x
	// pre material
	public int	initial_material;		// default material,					0
	public int	initial_material_back;	// default back material				-1
										// initial material: i1 [i2]		initial_material=i1, initial_meterial_back=i2
	// pre valce a generovane valce
	public boolean prisposob_sirku;		// zapina prisposobovanie hrubky nasledujucemu segmentu
										// taperet lines: flag		flag=on|off
	public int	delenie_kontur;			// nastavuje delenie kontur				32
										// countour sides: n
	public boolean twist_of_cylinders;		// ak = 0, minimalizuje vplyv / \ na toceni kontury			0
										// twist of cylinders: flag		flag=on|off
	public int	delenie_gule;			// vypozitava sa na zaklade delenie_kontur
		
	// kontury
	z_kontura kruh;
//	vector<z_kontura>kontury;
	
	// materialy
	Vector mat;
	
	public Lsystem_setting()
	{
		Reset();
		mat = new Vector();
		LoadMaterials();
		Vypocitaj_kruh(delenie_kontur);
	/*	zL_Material a;
		ZeroMemory( &a, sizeof(zL_Material));
		a.ambient.set( 0.3f, 0.3f, 0.3f);
		a.diffuse.set( 0.7f, 0.7f, 0.7f);
		a.emission.set( 0,0,0);
		a.specular.set( 1, 1, 1);
		a.shininess = 100;*/
	}
	void Vypocitaj_kruh(int delenie_uhla)
	{
		z_vnt a = new z_vnt();
		v ve = new v();
		kruh = new z_kontura();
		kruh.pocet = delenie_uhla;
		kruh.id = 0;
		kruh.v = new z_vnt[kruh.pocet];
		kruh.open = false;

		float delta = 360.f/(float)(delenie_uhla-1);
		for(int i=0; i<delenie_uhla; i++)
		{
			ve.set(1,0,0);
			ve.RotZ((float)i*delta);
			a.ve = new v(ve);
			a.n = new v(ve);
		//	a.t.x = (float)i/(float) (delenie_uhla-1);
		//	a.t.y = 0.f;
			kruh.v[i] = new z_vnt(a);
		}
	}
	public void Reset()
	{
		// vseobecne
	//	angle = 90;	// default uhol pre korytnacku

		// pre material
		initial_material = 0;		// default material
		initial_material_back = -1;	// default back material, ak -1 nepouziva sa back material

		// pre valce a generovane valce
		prisposob_sirku = true;		// zapina prisposobovanie hrubky nasledujucemu segmentu
		delenie_kontur = 16;		// nastavuje delenie kontur
		delenie_gule = 10;
		twist_of_cylinders = false;		// ak = 0, minimalizuje vplyv / \ na toceni kontury

		// pre osvetlenie
	/*	light_model_ambient.clear();
		light.clear();
		z_light a;
		a.ambient.set(0.3f,0.3f,0.3f);
		a.diffuse.set(0.7f,0.7f,0.7f);
		a.specular.set(1,1,1);
		a.position.set(0,0,1,0);
		light.push_back( a );*/
	//	svetlo = 1;
	}
	public Material mat(int i)
	{
		return (Material)mat.get(i);
	}
	public void LoadMaterials()
	{
		Material a = new Material();
		
		// 0 klasika, zelena
		// postupne, cez vsetky 
		a.diffuse = 0xffffff;
		mat.add(a);
		
		a.specular = 0;
		a.ambient = 0;
		for(int r=3; r<=255; r+=63)	// 255, 192, 129, 66, 3
		{
			for(int g=3; g<=255; g+=63)
			{
				for(int b=3; b<=255; b+=63)
				{
					a.diffuse = col.make(r,g,b);
					mat.add(new Material(a));
				}	
			}
		}
		a.ambient = 0xffffff;
		for(int r=3; r<=255; r+=63)	// 255, 192, 129, 66, 3
		{
			for(int g=3; g<=255; g+=63)
			{
				for(int b=3; b<=255; b+=63)
				{
					a.diffuse = col.make(r,g,b);
					mat.add(new Material(a));
				}	
			}
		}
		a.specular = 0xffffff;
		a.ambient = 0;
		for(int r=3; r<=255; r+=63)	// 255, 192, 129, 66, 3
		{
			for(int g=3; g<=255; g+=63)
			{
				for(int b=3; b<=255; b+=63)
				{
					a.diffuse = col.make(r,g,b);
					mat.add(new Material(a));
				}	
			}
		}
		a.ambient = 0xffffff;
		for(int r=3; r<=255; r+=63)	// 255, 192, 129, 66, 3
		{
			for(int g=3; g<=255; g+=63)
			{
				for(int b=3; b<=255; b+=63)
				{
					a.diffuse = col.make(r,g,b);
					mat.add(new Material(a));
				}	
			}
		}
		a.specular=0;
		a.ambient=0;
		a.diffuse=0;
		for(int r=3; r<=255; r+=63)	// 255, 192, 129, 66, 3
		{
			for(int g=3; g<=255; g+=63)
			{
				for(int b=3; b<=255; b+=63)
				{
					a.emission = col.make(r,g,b);
					mat.add(new Material(a));
				}	
			}
		}
		a.specular=0xffffff;
		for(int r=3; r<=255; r+=63)	// 255, 192, 129, 66, 3
		{
			for(int g=3; g<=255; g+=63)
			{
				for(int b=3; b<=255; b+=63)
				{
					a.emission = col.make(r,g,b);
					mat.add(new Material(a));
				}	
			}
		}
		a.ambient = 0;
		a.diffuse = 0xffffff;
		a.specular = 0xffffff;
		a.shininess = 32.f;
		a.emission = 0;
	}
}
