/*
 * Priklady.java
 *
 * Created on Sobota, 2004, november 6, 13:07
 */

/**
 *
 * @author  Peter Ovarik
 */

package lsystem;
import java.io.*;
import java.util.*;
import java.lang.*;
import javax.swing.*;
import javax.naming.directory.*;
import graphics.math.col.*;

public class Subory
{
    private String Hlavny_adresar_prikladov = "priklady";
    private String nazov_inf_suboru = "adresare.txt";
    
    public class Lsystem
    {
        //public String katergoria = "neznama";
        public String popis = "neznamy";
		public String popis_eng = "";
        public int default_iteracia = 1;
        public int bg_color = 0x000000;
        public boolean draw_ground = false;
        public boolean valce = true;
        public String lsystem = "";
    }
    
    public class Kategoria
    {
        public String nazov = "neznama";
		public String nazov_eng = "unknown";
        public Lsystem[] priklady;
    }
    
    //public Lsystem[] priklady;
    public Kategoria[] kategorie;
    
    // konstruktor
    public Subory()
    {
        String[] adresare = Nacitaj_neprazdne_riad(Hlavny_adresar_prikladov+"/"+nazov_inf_suboru);
        String sub_v_adresary = adresare[adresare.length-1];
        
        kategorie = new Kategoria[adresare.length-1];
        
        for(int i=0; i<adresare.length-1; i++)
        {
            Vector lsys_subory_pom = new Vector();
            String adresar = Hlavny_adresar_prikladov+"/"+adresare[i]+"/";
            String[] nazvy_sub_v_adresary = Nacitaj_neprazdne_riad(adresar+sub_v_adresary);
            kategorie[i] = new Kategoria();
            kategorie[i].nazov = nazvy_sub_v_adresary[0];
			kategorie[i].nazov_eng = nazvy_sub_v_adresary[1];
            for(int j=0; j<nazvy_sub_v_adresary.length; j++)
            {
                lsys_subory_pom.addElement(adresar+nazvy_sub_v_adresary[j]);
            }
            String[] lsys_subory = new String[lsys_subory_pom.size()-2];
            
            //kategorie[i].nazov = new String();
            //kategorie[i].priklady = new Lsystem[lsys_subory_pom.size()-1];
            
            
            for(int k=2; k<lsys_subory_pom.size(); k++)
            {
                lsys_subory[k-2] = (String)lsys_subory_pom.get(k);
            }
            //priklady = NacitajPriklady(lsys_subory);
            kategorie[i].priklady = NacitajPriklady(lsys_subory);
        }
        
    }
    
    private String[] Nacitaj_neprazdne_riad(String filename)
    {
        Vector riadky = Rozdel_na_riadky(NacitajSubor(filename));
        for(int i=0,d; i<riadky.size(); i++)
        {
            for(d=0; d<((String)riadky.get(i)).length() && ((String)riadky.get(i)).charAt(d)==' '; d++);
            if(d<((String)riadky.get(i)).length()) riadky.set(i,((String)riadky.get(i)).substring(d));
            else riadky.set(i,"");
            if((String)riadky.get(i)=="")
            {
                riadky.remove(i);
                i--;
            }
        }
        if(((String)riadky.get(0)).substring(0,Math.min(28,((String)riadky.get(0)).length())).compareTo("Chyba pri citani zo suboru: ")==0)
        {
            JOptionPane.showMessageDialog(null,"Nemozem nacitat subor: "+filename,"Chyba",JOptionPane.ERROR_MESSAGE);
            riadky.clear();
        }
        String[] vystup = new String[riadky.size()];
        for(int i=0; i<riadky.size(); i++)
        {
            vystup[i] = (String)riadky.get(i);
        }
        
        return vystup;
    }
    
    // nacita obsah suboru s nazvom filename a vrati ho ako retazec
    private String NacitajSubor(String filename)
    {
        String riadok, retazec = "";
        try
        {
            //LsysStr lsys = new LsysStr();
            InputStream stream = this.getClass().getResourceAsStream(filename);
            BufferedReader vstup = new BufferedReader(new InputStreamReader(stream));
            while((riadok = vstup.readLine())!=null)
            {
               retazec += riadok + "\r\n";
            }
            stream.close();
        }
        catch (Exception e)
        {
            retazec = "Chyba pri citani zo suboru: "+filename;
        }
        return retazec;
    }
    
    private Vector Rozdel_na_riadky(String obsah_sub)
    {
        Vector riad = new Vector();
        String pom = "";
        for(int j=0; j<obsah_sub.length(); j++)
        {
            if(obsah_sub.charAt(j)=='\r') continue;     // navrat vozika ingnorujeme
            if(obsah_sub.charAt(j)=='\n')             // riadok sa skoncil pridame do vektora
            {
                riad.addElement(pom);
                pom = "";
            }
            else pom+=obsah_sub.charAt(j);					
        }
        if(pom.length()>0) riad.addElement(pom);          // pridame posledny riadok
        return riad; 
    }
    
    private Lsystem[] NacitajPriklady(String[] filename)
    {
        Lsystem priklady[] = new Lsystem[filename.length];
        
        for(int i=0; i<priklady.length; i++)    // cez vsetky subory
        {
            String obsah_sub = new String();
            priklady[i] = new Lsystem();
            Vector riad = new Vector();
            String pom = "";
            
            obsah_sub = NacitajSubor(filename[i]);
            
            // nakuskujeme obsah subora do riadkov
            riad = Rozdel_na_riadky(obsah_sub);
                                 
            for(int k=0; k<riad.size(); k++)    // cez vsetky riadky
            {
                String riadok = (String)riad.get(k);
                int d;
                for(d=0; d<riadok.length() && riadok.charAt(d)==' '; d++);		// vynechame medzery
                if(d==riadok.length()) continue;                                 // ak sme na konci riadku, prejdeme na dalsi riadok
			
                String substr_title = riadok.substring(d,Math.min(d+6,riadok.length()));
				String substr_titlee = riadok.substring(d,Math.min(d+7,riadok.length()));
                //String substr_category = riadok.substring(d,Math.min(d+9,riadok.length()));
                String substr_iter = riadok.substring(d,Math.min(d+5,riadok.length()));
                String substr_bgcolor = riadok.substring(d,Math.min(d+8,riadok.length()));
                String substr_valce = riadok.substring(d,Math.min(d+10,riadok.length()));
                String substr_draw_ground = riadok.substring(d,Math.min(d+12,riadok.length()));
                
				if(substr_title.compareTo("title ")==0)
                {
                    priklady[i].popis = riadok.substring(d+6);
                    riad.remove(k);
                    k--;
                    continue;
                }
				
				if(substr_titlee.compareTo("titlee ")==0)
                {
                    priklady[i].popis_eng = riadok.substring(d+7);
                    riad.remove(k);
                    k--;
                    continue;
                }
                
                /*if(substr_category.compareTo("category ")==0)
                {
                    priklady[i].katergoria = riadok.substring(d+9);
                    riad.remove(k);
                    k--;
                    continue;
                }*/
                if(substr_iter.compareTo("iter ")==0)
                {
					int iter=1;
				
					try
					{
						iter = Integer.valueOf(riadok.substring(d+5)).intValue();
					}
					catch (Exception e)
					{
					}
						
                    if(iter>=0) priklady[i].default_iteracia = iter;
                    else priklady[i].default_iteracia = 0;
                    riad.remove(k);
                    k--;
                    continue;
                }
                
                if(substr_draw_ground.compareTo("draw_ground ")==0)
                {
					int stav;
                    try
					{
						stav = Integer.valueOf(riadok.substring(d+12)).intValue();
					}
					catch (Exception e)
					{
                        stav=0;
					}
					
                    if(stav==0) priklady[i].draw_ground = false;
                    if(stav==1) priklady[i].draw_ground = true;
                    riad.remove(k);
                    k--;
                    continue;
                }
                
                if(substr_valce.compareTo("cylinders ")==0)
                {
					int stav;
                    try
					{
						stav = Integer.valueOf(riadok.substring(d+10)).intValue();
					}
					catch (Exception e)
					{
                        stav=0;
					}
					
                    if(stav==0) priklady[i].valce = false;
                    if(stav==1) priklady[i].valce = true;
                    riad.remove(k);
                    k--;
                    continue;
                }
                
                if(substr_bgcolor.compareTo("bgcolor ")==0)
                {
					String farba= riadok.substring(d+8);
					String R="",G="",B="",pom_farba="";
                    int pocet = 0;
                    for(int l=0; l<farba.length(); l++)
                    {
                        if(farba.charAt(l)==' ')
                        {
                            if(pocet==0) R = pom_farba;
                            if(pocet==1) G = pom_farba;
                            if(pocet==2) B = pom_farba;
                            pom_farba="";
                            pocet++;
                        }
                        else pom_farba+=farba.charAt(l);
                    }
					if(pocet==2) B = pom_farba;
                    
                    float R1,G1,B1;
                    try {R1 = Float.parseFloat(R);}
                    catch(Exception e) {R1 = 0.0f;}
                    try {G1 = Float.parseFloat(G);}
                    catch(Exception e) {G1 = 0.0f;}
                    try {B1 = Float.parseFloat(B);}
                    catch(Exception e) {B1 = 0.0f;}
                    
                    priklady[i].bg_color = graphics.math.col.make(R1, G1, B1);
                    
                    riad.remove(k);
                    k--;
                    continue;
                }
            }
            
            if(priklady[i].popis=="neznamy")
            {
                int index1 = filename[i].lastIndexOf('/')+1;
                int index2 = filename[i].indexOf('.');
				if(index2<0) index2 = filename[i].length();
                priklady[i].popis = filename[i].substring(index1,index2);
            }
            
            for(int j=0; j<riad.size(); j++)
            {
                if((String)riad.get(j)=="")
                {
                    riad.remove(j);
                    j--;
                }
                else break;
            }
                        
            for(int j=0; j<riad.size(); j++)
            {
                if(j!=0) priklady[i].lsystem += "\r\n";
                priklady[i].lsystem += (String)riad.get(j);
           }
        }
        return priklady;
    }
}