/*
 * CKoryt.java
 *
 * Created on Streda, 2004, oktber 20, 14:24
 */

/**
 *
 * @author  Marek Mizanin
 */
package lsystem.korytnacka; 

import java.util.*;
import graphics.math.*;
import graphics.device.*;

//class v2 extends v{};		// trieda pre texturove koordinacie
class v4 extends v{};		// trieda pre farby (rgba)

public class Koryt
{
	public Kstav stav;				// aktualny stav korytnacky, pouzivam ako default hodnoty
	public Stack s_stav;			// zasobnik stavov korytnacky

	public boolean prisposob_sirku;		// zapina prisposobenie hrubky nasledujucemu segmentu
	public boolean	twist_of_cylinders;		// 0 - minimalizujeme tocenie kontury, t.j. vplyv (/,\)
	public int texture_id;	// id_aktualnej textury
	public GL gl;		// pointer to gl device
	
	public void Reset()
	{
		s_stav.clear();
		stav.clear();
	}
	public void Kresli_line(){Kresli_line(true);}
	public void Kresli_line(boolean color){}
	public void Kresli(){Kresli(true, true);}
	public void Kresli(boolean color){Kresli(color, true);}
	public void Kresli(boolean color, boolean light){}		// vykresli l-system, podla color a light sa pouziju farby a svetlo

	public void Koncove_vypocty(){}			// vola sa na konci
	public void Dokonci(){}					// vola sa z reset, f,G,g,]

	public void F(){F(1.0f);}
	public void F( float dlzka)
	{
		dlzka *= stav.dlzka;
		stav.p.add(v.mul(dlzka,stav.h));		// posunutie korytnacky v smere h	
		// + mod zaznamu polygonov
	}
	public void F( float dlzka, float hrubka)
	{
		dlzka *= stav.dlzka;
		stav.p.add(v.mul(dlzka,stav.h));		// posunutie korytnacky v smere h	
		stav.hrubka = hrubka;
		// + mod zaznamu polygonov
	}
	public void f(){f(1.0f);}
	public void f( float dlzka)
	{
		dlzka *= stav.dlzka;
		stav.p.add(v.mul(dlzka,stav.h));	// posunutie korytnacky v smere h
		// + mod zaznamu polygonov
	}
	public void G(){G(1.0f);}
	public void G( float dlzka)				// to iste ako F ale bez zaznamu polygonov
	{
		dlzka *= stav.dlzka;
		stav.p.add(v.mul(dlzka,stav.h));	// posunutie korytnacky v smere h	
	}
	public void g(){g(1.0f);}
	public void g( float dlzka)				// to iste ako f ale bez zaznamu polygonov
	{
		dlzka *= stav.dlzka;
		stav.p.add(v.mul(dlzka,stav.h));	// posunutie korytnacky v smere h	
	}
	public void plus(){plus(stav.uhol);}		// +
	public void minus(){minus(stav.uhol);}		// -
	public void xor(){xor(stav.uhol);}			// ^
	public void and(){and(stav.uhol);}			// &
	public void del(){del(stav.uhol);}			// /
	public void odel(){odel(stav.uhol);}		//"\"
	
	public void plus( float uhol)			// +
	{
		stav.l.ArbitraryRotate( uhol, stav.u);
		stav.h.ArbitraryRotate( uhol, stav.u);
		stav.minrot.ArbitraryRotate( uhol, stav.u);
	}
	public void minus( float uhol)		// -
	{
		stav.l.ArbitraryRotate(-uhol, stav.u);
		stav.h.ArbitraryRotate(-uhol, stav.u);
		stav.minrot.ArbitraryRotate(-uhol, stav.u);
	}
	public void xor( float uhol)			// ^
	{
		stav.u.ArbitraryRotate(-uhol, stav.l);
		stav.h.ArbitraryRotate(-uhol, stav.l);
		stav.minrot.ArbitraryRotate(-uhol, stav.l);
	}
	public void and( float uhol)			// &
	{
		stav.u.ArbitraryRotate( uhol, stav.l);
		stav.h.ArbitraryRotate( uhol, stav.l);
		stav.minrot.ArbitraryRotate( uhol, stav.l);		
	}
	public void del( float uhol)			// /
	{
		stav.u.ArbitraryRotate(-uhol, stav.h);
		stav.l.ArbitraryRotate(-uhol, stav.h);
	//	stav.t_posun.x += (uhol/360.f)*stav.t_mierka.x;
	}
	public void odel( float uhol)			//"\"
	{
		stav.u.ArbitraryRotate( uhol, stav.h);
		stav.l.ArbitraryRotate( uhol, stav.h);
	//	stav.t_posun.x -= (uhol/360.f)*stav.t_mierka.x;
	}
	public void or()						// |
	{
		stav.l.neg(); stav.h.neg(); stav.minrot.neg();
	}

	public void dolar()						// $
	{
		if(Math.abs(stav.l.y)>0.0f)			// inak je L v rovine
		{
			v ve = new v(0,1,0);		// normalovy vektor zeme, vektor opacny k smeru gravitacie
			stav.l = v.CROSS( ve, stav.h);
			stav.l.Normalize();
			stav.u = v.CROSS( stav.h, stav.l);
			stav.u.Normalize();		// pre istotu
		}		
	}
	public void zat_hran_otv()			// [
	{
		s_stav.push(new Kstav(stav));				// pridame do zasobnika
	}
	public void zat_hran_zat()			// ]
	{
		if(s_stav.empty())return;			// ak nie je nic v zasobniku return
		stav = (Kstav)s_stav.peek();		// prepiseme stav z vrcholom zasobnika
		s_stav.pop();						// uberieme z vrchola zasobnika
	}
	public void zat_zloz_otv()			// {
	{
		// vlozime prazdny list do zasobnika
	}
	public void zat_zloz_zat()			// }
	{		
	}
	public void bodka()					// .
	{		
	}

	public void dvoj_bodka(float r, float g, float b)		// :
	{	stav.color = col.make(r,g,b);	}
	public void bodko_ciarka(float r, float g, float b)		// ;
	{	stav.color = col.make(r,g,b);	}
	public void ciarka(float r, float g, float b)			// ,
	{	stav.color = col.make(r,g,b);	}
	public void uvodzovka(){uvodzovka(0.9f);}
	public void uvodzovka(float d)							// '
	{
		stav.dlzka*=d;
	}
	public void uvodzovka_dvojita(){uvodzovka_dvojita(1.1f);}
	public void uvodzovka_dvojita(float d)					// "
	{
		stav.dlzka*=d;
	}
	public void vykricnik()						// !
	{
		stav.hrubka*=0.909090909f;		// znizenie hrubky ciary
	//	stav.hrubka-=0.1f;		
	}
	public void vykricnik( float hrubka)		// !
	{
		stav.hrubka=hrubka;
	}
	public void mriezka()						// #
	{
		stav.hrubka*=1.1f;				// zvysenie hrubky ciary
	}
	public void mriezka( float hrubka)			// #
	{
		stav.hrubka=hrubka;
	}
//	void percento();							// %

	public void zc1(){zc1(stav.hrubka);}
	public void zc1( float hrubka){}			// vlozi disk urceny na zaciatok valca
	public void zc2(){zc2(stav.hrubka);}
	public void zc2( float hrubka){}			// vlozi disk urceny na koniec valca
	public void zO (){}							// vlozi gulu
	public void zO ( float hrubka){}				// vlozi gulu s priemerom hrubka
	public void zO1(){zO1(stav.hrubka);}
	public void zO1( float hrubka){}			// vlozi polgulu, urcena na zaciatok valca
	public void zO2(){zO2(stav.hrubka);}
	public void zO2( float hrubka){}			// vlozi polgulu, urcena na koniec valca
	
	public void zGs(){}							// startuje generovanie valcov
	public void zGc(){zGc(4);}
	public void zGc( int n){}	// pokracuje v generovani valcov, definuje kontrolny bod, n je pocet pasov nakreslenych od posledneho kontrolneho bodu
	public void zGe(){zGe(4);}
	public void zGe( int n){}	// ukonci generovanie valcov, nakresli n pasov od posledneho kontrolneho bodu
	public void zGt( float s){zGt(s, 1.2f);}
	public void zGt(){ zGt(1.2f, 1.2f);}
	public void zGt( float s, float e){}	// kontroluje dlzku smerovych vektorov, pouzivanych pre generovanie valcov
	public void zGr( float angle1, float length, float angle2, float length2){}	// nastavuje Hermitovu krivku pre zmenu hrubky
	public void zGr(){zGr(0);}
	public void zGr( int flag){}					// zapina a vypina zmenu hrubky, pri zmene dlzky segmentu

	public void z_mriezka(){z_mriezka(0);}
	public void z_mriezka( float contour_id){}	// nastavy konturu pre generovanie valcov, 0 je kruh

	public Koryt()
	{
	//	Reset();
		prisposob_sirku=true;
		twist_of_cylinders = false;
		texture_id = 0;
		s_stav = new Stack();
		stav = new Kstav();
	}
}
