/*
 * Koryt_Gule.java
 *
 * Created on Pondelok, 2004, november 8, 16:49
 */

package lsystem.korytnacka;
import graphics.math.*;
import graphics.device.*;
import java.util.*;
/**
 *
 * @author  Marek Mizanin
 */

class z_gula
{
	// pole vrcholov
	// dolny pol (0,0,-1), poc_pasov krat pas vrchlov o velkosti del_x, horny pol (0,0,1)
	z_vnt	v[];		// velkost pola je pocet_pasov*del_x+2
	int del_x;			// delenie v rovine xy = delenie_uhla+1
	int pocet_pasov;	// delenie v smere z
//	int	texture_id;		// id aktualnej textury, ak==0 texturovanie je vypnute
//	char	texture_env;	// GL_MODULATE(0), alebo GL_DECAL(1)
	Material		mat;	// aktualny material, nemoze sa rovnat NULL
	int				colorDiffuse;
}

public class Koryt_Gule extends Koryt_PolGule
{
	private Vector gule;
	boolean nedokoncena_gula;
	Kstav stav_gula;
	z_gula vypoc_gula;			// vypocitane body, na gule o polomere 1
	
	public Koryt_Gule()
	{
		super();
		gule = new Vector();
		nedokoncena_gula = false;
		vypoc_gula = new z_gula();
		vypoc_gula.del_x = 0;
		vypoc_gula.pocet_pasov = 0;
		Vypocitaj_body_na_guli( 24, 11); //16, 7);
	}
	public void Vypocitaj_body_na_guli( int delenie_uhla, int pocet_pasov)
	{
		int i;
		v a=new v(),b=new v();

		if(vypoc_gula.del_x==delenie_uhla+1 && vypoc_gula.pocet_pasov==pocet_pasov)return;
		vypoc_gula.del_x = delenie_uhla+1;
		vypoc_gula.pocet_pasov = pocet_pasov;
		
		int count_points = vypoc_gula.pocet_pasov*vypoc_gula.del_x+2;
		vypoc_gula.v = new z_vnt[count_points];

		for(int z=0; z<count_points; z++)
			vypoc_gula.v[z] = new z_vnt();

		vypoc_gula.v[0].ve = new v(0,0,-1);
		vypoc_gula.v[0].n = new v(0,0,-1);
	//	vypoc_gula.v[0].t.x = 0.5f;
	//	vypoc_gula.v[0].t.y =-0.5f;

		i = vypoc_gula.del_x*vypoc_gula.pocet_pasov+1;
		vypoc_gula.v[i].ve = new v(0,0, 1);
		vypoc_gula.v[i].n = new v(0,0, 1);
	//	vypoc_gula.v[i].t.x = 0.5f;
	//	vypoc_gula.v[i].t.y = 0.5f;

		for(int z=0; z<vypoc_gula.pocet_pasov; z++)
		{
			a.set(0,0,-1);
			a.RotY( -180.f*(float)(z+1)/(float)(vypoc_gula.pocet_pasov+1));
			for(int x=0; x<vypoc_gula.del_x; x++)
			{
				b.set(a);
				b.RotZ( -360.f*(float)x/(float)(vypoc_gula.del_x-1));
				i = z*vypoc_gula.del_x+x+1;
				vypoc_gula.v[i].ve = new v(b);
				vypoc_gula.v[i].n = new v(b);
			//	vypoc_gula.v[i].t.x = (float)x/(float)(vypoc_gula.del_x-1);
			//	vypoc_gula.v[i].t.y = (float)(z+1)/(float)(vypoc_gula.pocet_pasov+1)-0.5f;
			}
		}
		vypoc_gula.mat = null;
	}
	z_gula gule(int i)
	{
		return (z_gula)gule.get(i);
	}
	public void Reset()
	{
		super.Reset();
		gule.clear();
	}
	public void Kresli(boolean color, boolean light)
	{
		super.Kresli(color, light);
		
	//	if(light)gl.glEnableLighting();		// zapne svetlo ak je light==1
	//	else gl.glDisableLighting();
		
		for(int i=0; i<gule.size(); i++)		// cez vsetky valce
		{

		//	if(light&&color)gule(i).mat.set();

		/*	if(((z_gula)gule.get(i)).texture_id!=0)
			{
				if(((z_gula)gule.get(i)).texture_id!=texture_id)
				{
					if(!texture_id)glEnable(GL_TEXTURE_2D);
					glBindTexture( GL_TEXTURE_2D, ((z_gula)gule.get(i)).texture_id);
					texture_id = ((z_gula)gule.get(i)).texture_id;
				}
				if(((z_gula)gule.get(i)).texture_env)glDisable(GL_LIGHTING);
			}
			else
			{
				if(texture_id!=0)
				{
					glDisable(GL_TEXTURE_2D);
					texture_id = 0;
				}
			}*/
			gl.glMaterial(((z_gula)gule.get(i)).mat);
			gl.material.diffuse = ((z_gula)gule.get(i)).colorDiffuse;
					
			gl.glBegin(GL.GL_TRIANGLE_FAN);
			int end = ((z_gula)gule.get(i)).del_x+1;
			for(int j=0; j<end; j++)
			{
			//	gl.glTexCoord2fv( ((z_gula)gule.get(i)).v[j].t.v );
				gl.glNormal3fv( ((z_gula)gule.get(i)).v[j].n );
				gl.glVertex3fv( ((z_gula)gule.get(i)).v[j].ve );
			}
			gl.glEnd();

			end = ((z_gula)gule.get(i)).pocet_pasov-1;
			for(int pas=0; pas<end; pas++)
			{
				gl.glBegin(GL.GL_TRIANGLE_STRIP);
				int endj = (pas+1)*((z_gula)gule.get(i)).del_x+1;
				for(int j=pas*((z_gula)gule.get(i)).del_x+1; j<endj; j++)
				{
					int jj = j+((z_gula)gule.get(i)).del_x;
				//	gl.glTexCoord2fv( ((z_gula)gule.get(i)).v[j].t.v );
					gl.glNormal3fv( ((z_gula)gule.get(i)).v[j].n );
					gl.glVertex3fv( ((z_gula)gule.get(i)).v[j].ve );

				//	gl.glTexCoord2fv( ((z_gula)gule.get(i)).v[jj].t.v );
					gl.glNormal3fv( ((z_gula)gule.get(i)).v[jj].n );
					gl.glVertex3fv( ((z_gula)gule.get(i)).v[jj].ve );
				}
				gl.glEnd();
			}

			gl.glBegin(GL.GL_TRIANGLE_FAN);
			int j = ((z_gula)gule.get(i)).del_x*((z_gula)gule.get(i)).pocet_pasov+1;
		//	gl.glTexCoord2fv( ((z_gula)gule.get(i)).v[j].t.v );
			gl.glNormal3fv( ((z_gula)gule.get(i)).v[j].n );
			gl.glVertex3fv( ((z_gula)gule.get(i)).v[j].ve );
		//	end = ((z_gula)gule.get(i)).del_x*((z_gula)gule.get(i)).pocet_pasov+2;
			end = (((z_gula)gule.get(i)).pocet_pasov-1)*((z_gula)gule.get(i)).del_x+1;
			for( j= ((z_gula)gule.get(i)).del_x*((z_gula)gule.get(i)).pocet_pasov+1; j>=end; j--)
		//	for( j= (((z_gula)gule.get(i)).pocet_pasov-1)*((z_gula)gule.get(i)).del_x+1; j<end; j++)
			{
			//	gl.glTexCoord2fv( ((z_gula)gule.get(i)).v[j].t.v );
				gl.glNormal3fv( ((z_gula)gule.get(i)).v[j].n );
				gl.glVertex3fv( ((z_gula)gule.get(i)).v[j].ve );
			}
			gl.glEnd();
		}
	//	if(light)gl.glDisableLighting();
	}
	private void Dokonc_gulu(float hrubka)
	{
		z_gula a = new z_gula();
		// potrebujeme otocit x na -left, y na up a z na head
		mat vt=new mat(),nt=new mat();		// vertex transformation, normal transformation

		nt.MakeMatrix( stav_gula.l, stav_gula.u, stav_gula.h);
		nt = mat.Transpose(nt);
		vt.set(nt);
		if(prisposob_sirku)				// pouzije sa zadana hrubka
			vt.Scale( hrubka, hrubka, hrubka);
		else							// pouzije sa hrubka v case spracovania @O
			vt.Scale( stav_gula.hrubka, stav_gula.hrubka, stav_gula.hrubka);
		vt.m14 = stav_gula.p.x;
		vt.m24 = stav_gula.p.y;
		vt.m34 = stav_gula.p.z;

		a.del_x = vypoc_gula.del_x;
		a.pocet_pasov = vypoc_gula.pocet_pasov;
		a.mat = stav_gula.mat;
		a.colorDiffuse = stav_gula.color;
	//	a.texture_id = stav_gula.texture_id;
	//	a.texture_env = stav_gula.texture_env;
		int count_points = a.pocet_pasov*a.del_x+2;
		a.v = new z_vnt[count_points];

		for(int i=0; i<count_points; i++)
		{
			a.v[i] = new z_vnt();
			a.v[i].n = nt.mul(vypoc_gula.v[i].n);
			a.v[i].ve = vt.mul(vypoc_gula.v[i].ve);
		//	a.v[i].t.x = stav_gula.t_posun.x + stav_gula.t_mierka.x*vypoc_gula.v[i].t.x;
		//	a.v[i].t.y = stav_gula.t_posun.y + stav_gula.t_mierka.y*vypoc_gula.v[i].t.y;
		}
		gule.add( a);
		nedokoncena_gula=false;
	}
	public void Koncove_vypocty()
	{
		super.Koncove_vypocty();
		if(nedokoncena_gula)Dokonc_gulu(0.5f*stav.hrubka*stav.dlzka);
	}
	public void Dokonci()						// vola sa z reset, f,g,],!,!(),#,#()
	{
		super.Dokonci();
		if(nedokoncena_gula)Dokonc_gulu(0.5f*stav.hrubka*stav.dlzka);
	}
	public void zO ()								// vlozi gulu
	{
		if(nedokoncena_gula)Dokonc_gulu(0.5f*stav.hrubka*stav.dlzka);
		stav_gula = new Kstav(stav);
		stav_gula.hrubka = 0.5f*stav.hrubka*stav.dlzka;
		nedokoncena_gula = true;
	}
	public void zO ( float hrubka)			// vlozi gulu
	{
		if(nedokoncena_gula)Dokonc_gulu(0.5f*stav.hrubka*stav.dlzka);
		stav_gula = new Kstav(stav);
		stav_gula.hrubka = 0.5f*hrubka*stav.dlzka;
		Dokonc_gulu(stav_gula.hrubka);			// rovno sa moze vypocitat
	}
}
