/*
 * Koryt_PolpolGule.java
 *
 * Created on Streda, 2004, november 10, 12:27
 */

package lsystem.korytnacka;
import graphics.math.*;
import graphics.device.*;
import java.util.*;
/**
 *
 * @author  Marek Mizanin
 */
class z_PolGula
{
	// pole vrcholov
	// dolny pol (0,0,-1), poc_pasov krat pas vrchlov o velkosti del_x, horny pol (0,0,1)
	z_vnt	v[];		// velkost pola je pocet_pasov*del_x+1
	int del_x;			// delenie v rovine xy = delenie_uhla+1
	int pocet_pasov;	// delenie v smere z
	Material		mat;	// aktualny material, nemoze sa rovnat NULL
	int				colorDiffuse;
}

public class Koryt_PolGule  extends Koryt
{
	private Vector polGule;
	boolean nedokoncena_polGula;
	Kstav stav_polGula;
	z_PolGula vypoc_polGula;			// vypocitane body, na polGule o polomere 1
	
	public Koryt_PolGule()
	{
		super();
		polGule = new Vector();
		nedokoncena_polGula = false;
		vypoc_polGula = new z_PolGula();
		vypoc_polGula.del_x = 0;
		vypoc_polGula.pocet_pasov = 0;
		Vypocitaj_body_na_polGuli( 16, 4);
		polGule.add(vypoc_polGula);
	}
	public void Vypocitaj_body_na_polGuli( int delenie_uhla, int pocet_pasov)
	{
		int i;
		v a=new v(),b=new v();

		if(vypoc_polGula.del_x==delenie_uhla+1 && vypoc_polGula.pocet_pasov==pocet_pasov)return;
		vypoc_polGula.del_x = delenie_uhla+1;
		vypoc_polGula.pocet_pasov = pocet_pasov;
		
		int count_points = vypoc_polGula.pocet_pasov*vypoc_polGula.del_x+1;
		vypoc_polGula.v = new z_vnt[count_points];

		for(int z=0; z<count_points; z++)
			vypoc_polGula.v[z] = new z_vnt();

		i = vypoc_polGula.del_x*vypoc_polGula.pocet_pasov;
		vypoc_polGula.v[i].ve = new v(0,0, 1);
		vypoc_polGula.v[i].n = new v(0,0, 1);
	//	vypoc_polGula.v[i].t.x = 0.5f;
	//	vypoc_polGula.v[i].t.y = 0.5f;

		for(int z=0; z<vypoc_polGula.pocet_pasov; z++)
		{
			a.set(1,0,0);
			a.RotY( -90.f*(float)(z)/(float)(vypoc_polGula.pocet_pasov));
			for(int x=0; x<vypoc_polGula.del_x; x++)
			{
				b.set(a);
				b.RotZ( -360.f*(float)x/(float)(vypoc_polGula.del_x-1));
				i = z*vypoc_polGula.del_x+x;
				vypoc_polGula.v[i].ve = new v(b);
				vypoc_polGula.v[i].n = new v(b);
			//	vypoc_polGula.v[i].t.x = (float)x/(float)(vypoc_polGula.del_x-1);
			//	vypoc_polGula.v[i].t.y = (float)(z+1)/(float)(vypoc_polGula.pocet_pasov+1)-0.5f;
			}
		}
		vypoc_polGula.mat = null;
	}
	public void Kresli(boolean color, boolean light)
	{
		super.Kresli(color, light);
		
	//	if(light)gl.glEnableLighting();		// zapne svetlo ak je light==1
	//	else gl.glDisableLighting();
		
		for(int i=0; i<polGule.size(); i++)		// cez vsetky valce
		{
		//	if(light&&color)gule(i).mat.set();

		/*	if(((z_PolGula)polGule.get(i)).texture_id!=0)
			{
				if(((z_PolGula)polGule.get(i)).texture_id!=texture_id)
				{
					if(!texture_id)glEnable(GL_TEXTURE_2D);
					glBindTexture( GL_TEXTURE_2D, ((z_PolGula)polGule.get(i)).texture_id);
					texture_id = ((z_PolGula)polGule.get(i)).texture_id;
				}
				if(((z_PolGula)polGule.get(i)).texture_env)glDisable(GL_LIGHTING);
			}
			else
			{
				if(texture_id!=0)
				{
					glDisable(GL_TEXTURE_2D);
					texture_id = 0;
				}
			}*/

		/*	gl.glBegin(GL.GL_TRIANGLE_FAN);
			int end = ((z_PolGula)polGule.get(i)).del_x+1;
			for(int j=0; j<end; j++)
			{
			//	gl.glTexCoord2fv( ((z_PolGula)polGule.get(i)).v[j].t.v );
				gl.glNormal3fv( ((z_PolGula)polGule.get(i)).v[j].n );
				gl.glVertex3fv( ((z_PolGula)polGule.get(i)).v[j].ve );
			}
			gl.glEnd();*/

			gl.glMaterial(((z_PolGula)polGule.get(i)).mat);
			gl.material.diffuse = ((z_PolGula)polGule.get(i)).colorDiffuse;
			
			int end = ((z_PolGula)polGule.get(i)).pocet_pasov-1;
			for(int pas=0; pas<end; pas++)
			{
				gl.glBegin(GL.GL_TRIANGLE_STRIP);
				int endj = (pas+1)*((z_PolGula)polGule.get(i)).del_x;
				for(int j=pas*((z_PolGula)polGule.get(i)).del_x; j<endj; j++)
				{
					int jj = j+((z_PolGula)polGule.get(i)).del_x;
				//	gl.glTexCoord2fv( ((z_PolGula)polGule.get(i)).v[j].t.v );
					gl.glNormal3fv( ((z_PolGula)polGule.get(i)).v[j].n );
					gl.glVertex3fv( ((z_PolGula)polGule.get(i)).v[j].ve );

				//	gl.glTexCoord2fv( ((z_PolGula)polGule.get(i)).v[jj].t.v );
					gl.glNormal3fv( ((z_PolGula)polGule.get(i)).v[jj].n );
					gl.glVertex3fv( ((z_PolGula)polGule.get(i)).v[jj].ve );
				}
				gl.glEnd();
			}

			gl.glBegin(GL.GL_TRIANGLE_FAN);
			int j = ((z_PolGula)polGule.get(i)).del_x*((z_PolGula)polGule.get(i)).pocet_pasov;
		//	gl.glTexCoord2fv( ((z_PolGula)polGule.get(i)).v[j].t.v );
			gl.glNormal3fv( ((z_PolGula)polGule.get(i)).v[j].n );
			gl.glVertex3fv( ((z_PolGula)polGule.get(i)).v[j].ve );
		//	end = ((z_PolGula)polGule.get(i)).del_x*((z_PolGula)polGule.get(i)).pocet_pasov+2;
			end = (((z_PolGula)polGule.get(i)).pocet_pasov-1)*((z_PolGula)polGule.get(i)).del_x;
			for( j= ((z_PolGula)polGule.get(i)).del_x*((z_PolGula)polGule.get(i)).pocet_pasov; j>=end; j--)
		//	for( j= (((z_PolGula)polGule.get(i)).pocet_pasov-1)*((z_PolGula)polGule.get(i)).del_x+1; j<end; j++)
			{
			//	gl.glTexCoord2fv( ((z_PolGula)polGule.get(i)).v[j].t.v );
				gl.glNormal3fv( ((z_PolGula)polGule.get(i)).v[j].n );
				gl.glVertex3fv( ((z_PolGula)polGule.get(i)).v[j].ve );
			}
			gl.glEnd();
		}
	//	if(light)gl.glDisableLighting();
	}
	public void Reset()
	{
		super.Reset();
		polGule.clear();
	}
	void Dokonc_polGulu(float hrubka)
	{
		z_PolGula a = new z_PolGula();
		// potrebujeme otocit x na -left, y na up a z na head
		mat vt=new mat(),nt=new mat();		// vertex transformation, normal transformation

		nt.MakeMatrix( stav_polGula.l, stav_polGula.u, stav_polGula.h);
		nt = mat.Transpose(nt);
		vt.set(nt);
		if(prisposob_sirku)				// pouzije sa zadana hrubka
			vt.Scale( hrubka, hrubka, hrubka);
		else							// pouzije sa hrubka v case spracovania @O
			vt.Scale( stav_polGula.hrubka, stav_polGula.hrubka, stav_polGula.hrubka);
		vt.m14 = stav_polGula.p.x;
		vt.m24 = stav_polGula.p.y;
		vt.m34 = stav_polGula.p.z;

		a.del_x = vypoc_polGula.del_x;
		a.pocet_pasov = vypoc_polGula.pocet_pasov;
		a.mat = stav_polGula.mat;
		a.colorDiffuse = stav_polGula.color;
	//	a.texture_id = stav_polGula.texture_id;
	//	a.texture_env = stav_polGula.texture_env;
		int count_points = a.pocet_pasov*a.del_x+1;
		a.v = new z_vnt[count_points];

		for(int i=0; i<count_points; i++)
		{
			a.v[i] = new z_vnt();
			a.v[i].n = nt.mul(vypoc_polGula.v[i].n);
			a.v[i].ve = vt.mul(vypoc_polGula.v[i].ve);
		//	a.v[i].t.x = stav_polGula.t_posun.x + stav_polGula.t_mierka.x*vypoc_polGula.v[i].t.x;
		//	a.v[i].t.y = stav_polGula.t_posun.y + stav_polGula.t_mierka.y*vypoc_polGula.v[i].t.y;
		}
		polGule.add( a);
		nedokoncena_polGula=false;
	}
	public void Koncove_vypocty()
	{
		super.Koncove_vypocty();
		if(nedokoncena_polGula)Dokonc_polGulu(0.5f*stav.hrubka*stav.dlzka);
	}
	public void Dokonci()						// vola sa z reset, f,g,],!,!(),#,#()
	{
		super.Dokonci();
		if(nedokoncena_polGula)Dokonc_polGulu(0.5f*stav.hrubka*stav.dlzka);
	}
	public void zO1 ()								// vlozi gulu
	{
		if(nedokoncena_polGula)Dokonc_polGulu(0.5f*stav.hrubka*stav.dlzka);
		stav_polGula = new Kstav(stav);
		stav_polGula.hrubka = 0.5f*stav.hrubka*stav.dlzka;
		stav_polGula.l.neg(); stav_polGula.h.neg(); stav_polGula.minrot.neg();
		nedokoncena_polGula = true;
	}
	public void zO1 ( float hrubka)			// vlozi gulu
	{
		if(nedokoncena_polGula)Dokonc_polGulu(0.5f*stav.hrubka*stav.dlzka);
		stav_polGula = new Kstav(stav);
		stav_polGula.l.neg(); stav_polGula.h.neg(); stav_polGula.minrot.neg();
		stav_polGula.hrubka = 0.5f*hrubka*stav.dlzka;
		Dokonc_polGulu(stav_polGula.hrubka);			// rovno sa moze vypocitat
	}
	public void zO2 ()								// vlozi gulu
	{
		if(nedokoncena_polGula)Dokonc_polGulu(0.5f*stav.hrubka*stav.dlzka);
		stav_polGula = new Kstav(stav);
		stav_polGula.hrubka = 0.5f*stav.hrubka*stav.dlzka;
		nedokoncena_polGula = true;
	}
	public void zO2 ( float hrubka)			// vlozi gulu
	{
		if(nedokoncena_polGula)Dokonc_polGulu(0.5f*stav.hrubka*stav.dlzka);
		stav_polGula = new Kstav(stav);
		stav_polGula.hrubka = 0.5f*hrubka*stav.dlzka;
		Dokonc_polGulu(stav_polGula.hrubka);			// rovno sa moze vypocitat
	}
}
