/*
 * Koryt_Valce.java
 *
 * Created on Sobota, 2004, november 6, 17:17
 */

package lsystem.korytnacka;
import graphics.math.*;
import graphics.device.*;
import java.util.*;
/**
 *
 * @author  Marek Mizanin
 */
class z_valec
{
	z_vnt dolna[];	// pole obsahujuce vrcholy, prislusne normaly a texturove koordinacie dolnej podstavy, velkost pola je poc_bodov
	z_vnt horna[];	// pole obsahujuce vrcholy, prislusne normaly a texturove koordinacie hornej podstavy, velkost pola je poc_bodov
	int poc_bodov;
//	int	texture_id;		// id aktualnej textury, ak==0 texturovanie je vypnute
//	char	texture_env;	// GL_MODULATE(0), alebo GL_DECAL(1)
	Material		mat;			// aktualny material, nemoze sa rovnat NULL
//	Material		mat_back;		// aktualny vnutorny material,   moze sa rovnat NULL
	int				colorDiffuse;
	
	boolean obojstranne_osvetlenie;		// zapina obojstranne osvetlenie
	public z_valec()
	{
		dolna = null;
		horna = null;
		poc_bodov = 0;
		mat = null;
	//	mat_back = null;
		obojstranne_osvetlenie = false;
	//	colorDiffuse = 0xffffff;
	}
};

public class Koryt_Valce extends Koryt_Listy
{
	private Vector valce;
	
	z_valec akt_valec;
	Kstav	akt_valec_stav;
	boolean	nedokonceny_valec;
	
	public Koryt_Valce()
	{
		super();
		valce = new Vector();
		nedokonceny_valec = false;
	}
	public void Reset()
	{
		Dokonci();
		super.Reset();
		valce.clear();
	}
	z_valec valce(int i)
	{
		return (z_valec)valce.get(i);
	}
	public void Kresli(boolean color, boolean light)
	{
		super.Kresli(color, light);
		
	//	if(light)gl.glEnableLighting();		// zapne svetlo ak je light==1
	//	else gl.glDisableLighting();
		
		for(int i=0; i<valce.size(); i++)		// cez vsetky valce
		{

		//	if(valce(i).obojstranne_osvetlenie)
		//		glLightModelf( GL_LIGHT_MODEL_TWO_SIDE, 1.0f);
		//	else
		//		glLightModelf( GL_LIGHT_MODEL_TWO_SIDE, 0.0f);
		//	if(light&&color)
			{
			//	if(valce(i).mat_back!=null)
				{
					gl.glMaterial(valce(i).mat);
					gl.material.diffuse = valce(i).colorDiffuse;
				//	valce(i).mat_back.setBack();
				}
			//	else
			//		valce(i).mat.set();
			}
		/*	if(valce(i).texture_id!=0)
			{
				if(valce(i).texture_id!=texture_id)
				{
					if(!texture_id)glEnable(GL_TEXTURE_2D);
					glBindTexture( GL_TEXTURE_2D, valce(i).texture_id);
					texture_id = valce(i).texture_id;
				}
				if(valce(i).texture_env)glDisable(GL_LIGHTING);
			}
			else
			{
				if(texture_id!=0)
				{
					glDisable(GL_TEXTURE_2D);
					texture_id = 0;
				}
			}*/

			gl.glBegin(GL.GL_TRIANGLE_STRIP);
			try{
            for(int j=0; j<((z_valec)valce.get(i)).poc_bodov; j++)
			{
			//	gl.glTexCoord2fv( valce(i).dolna[j].t.v);
				gl.glNormal3fv( ((z_valec)valce.get(i)).dolna[j].n );
				gl.glVertex3fv( ((z_valec)valce.get(i)).dolna[j].ve );

			//	gl.glTexCoord2fv( valce(i).horna[j].t.v);
				gl.glNormal3fv( ((z_valec)valce.get(i)).horna[j].n );
				gl.glVertex3fv( ((z_valec)valce.get(i)).horna[j].ve );
			}
            }
            catch(Exception e) {}
            gl.glEnd();
		}
	//	gl.glLightModelf( GL_LIGHT_MODEL_TWO_SIDE, 0.0f);	// obojstranne osvetlenie
	//	if(light)gl.glDisableLighting();
	}
	public void Koncove_vypocty()
	{
		if(nedokonceny_valec)KoniecValca( 0.5f*stav.hrubka*stav.dlzka);
		super.Koncove_vypocty();
	}
	
	public void Dokonci()
	{
		super.Dokonci();
		if(nedokonceny_valec)KoniecValca();
	}
	public void F( float dlzka)
	{
		super.Dokonci();
		if(nedokonceny_valec)KoniecValca( 0.5f*stav.hrubka*stav.dlzka);
		ZaciatokValca( 0.5f*stav.hrubka*stav.dlzka);
		super.F( dlzka);
	//	stav.t_posun.y += stav.t_mierka.y*dlzka;
	}

	public void F( float dlzka, float hrubka)
	{
		super.Dokonci();
		if(nedokonceny_valec)KoniecValca( 0.5f*hrubka*stav.dlzka);
		ZaciatokValca( 0.5f*hrubka*stav.dlzka);
		super.F( dlzka, hrubka);
	//	stav.t_posun.y += stav.t_mierka.y*dlzka;
	}

	public void f( float dlzka)
	{
		Dokonci();
		super.f( dlzka);
	}

	public void G( float dlzka)
	{
		Dokonci();
		ZaciatokValca( 0.5f*stav.hrubka*stav.dlzka);
		super.G( dlzka);
	//	stav.t_posun.y += stav.t_mierka.y*dlzka;
	}

	public void g( float dlzka)
	{
		Dokonci();
		super.g(dlzka);
	//	stav.t_posun.y += stav.t_mierka.y*dlzka;
	}

	public void zat_hran_zat()					// ]
	{
		Dokonci();
		super.zat_hran_zat();
	}
	public void ZaciatokValca(){ZaciatokValca(0.5f*stav.hrubka*stav.dlzka);}
	public void ZaciatokValca( float hrubka)
	{
		mat vt=new mat(),nt=new mat();		// vertex transformation, normal transformation
		
		akt_valec = new z_valec();
		
		if(twist_of_cylinders)		// tocime konturov normalne
		{
			// potrebujeme otocit x na -left, y na up a z na head
			nt.MakeMatrix( v.neg(stav.l), stav.u, stav.h);
		}
		else			// minimalizujeme tocenie konturov
		{
			// potrebujeme otocit x na minrot, y na CROSS() a z na head
			nt.MakeMatrix( stav.minrot, v.CROSS( stav.minrot, stav.h), stav.h);
		}
		nt = mat.Transpose(nt);
		vt.set(nt);

		if(hrubka<0.0001f)hrubka=0.0001f;			// aby neboli problemy pri vypocte normalovych vektorov
		vt.Scale( hrubka, hrubka, hrubka);
		vt.m14 = stav.p.x;
		vt.m24 = stav.p.y;
		vt.m34 = stav.p.z;

		akt_valec.poc_bodov = stav.kontura.pocet;
		akt_valec.dolna = new z_vnt[akt_valec.poc_bodov];
		akt_valec.horna = new z_vnt[akt_valec.poc_bodov];
		for(int i=0; i<akt_valec.poc_bodov; i++)
		{
			akt_valec.dolna[i] = new z_vnt();
			akt_valec.horna[i] = new z_vnt();
			akt_valec.dolna[i].ve = mat.mul(vt,stav.kontura.v[i].ve);
			akt_valec.dolna[i].n = mat.mul(nt,stav.kontura.v[i].n);
		//	akt_valec.dolna[i].t.x = stav.t_posun.x + stav.t_mierka.x*stav.kontura.v[i].t.x;
		//	akt_valec.dolna[i].t.y = stav.t_posun.y;
		}
		akt_valec.mat = stav.mat;
		akt_valec.colorDiffuse = stav.color;
		/*if(stav.kontura.open)
		{
			akt_valec.obojstranne_osvetlenie = true;
			akt_valec.mat_back = stav.mat_back;
		}
		else
		{
			akt_valec.obojstranne_osvetlenie = false;
			akt_valec.mat_back = null;
		}*/
	//	akt_valec.texture_id = stav.texture_id;
	//	akt_valec.texture_env = stav.texture_env;
		akt_valec_stav = new Kstav(stav);
		akt_valec_stav.hrubka = hrubka;
		nedokonceny_valec = true;
	}
	
	public void KoniecValca(){KoniecValca(0.5f*stav.hrubka*stav.dlzka);}
	public void KoniecValca( float hrubka)
	{
	//	float tx;

		mat vt=new mat(),nt=new mat();		// vertex transformation, normal transformation

		if(twist_of_cylinders)		// tocime konturov normalne
		{
			// potrebujeme otocit x na -left, y na up a z na head
			nt.MakeMatrix( v.neg(akt_valec_stav.l), akt_valec_stav.u, akt_valec_stav.h);
		}
		else			// minimalizujeme tocenie konturov
		{
			// potrebujeme otocit x na minrot, y na CROSS() a z na head
			nt.MakeMatrix( akt_valec_stav.minrot, v.CROSS( akt_valec_stav.minrot, akt_valec_stav.h), akt_valec_stav.h);
		}
		nt = mat.Transpose(nt);
		vt.set(nt);

		if(prisposob_sirku)
		{
			if(hrubka<0.0001f)hrubka=0.0001f;			// aby neboli problemy pri vypocte normalovych vektorov
			vt.Scale( hrubka, hrubka, hrubka);
		}
		else
			vt.Scale( akt_valec_stav.hrubka, akt_valec_stav.hrubka, akt_valec_stav.hrubka);
		vt.m14 = stav.p.x;
		vt.m24 = stav.p.y;
		vt.m34 = stav.p.z;

	//	tx=0;
		for(int i=0; i<akt_valec.poc_bodov; i++)
		{
		//	tx = (float)i/(float)(akt_valec.poc_bodov-1);
			akt_valec.horna[i].ve = mat.mul(vt,stav.kontura.v[i].ve);
	//		akt_valec.horna[i].n = nt*stav.kontura.v[i].n;
		//	akt_valec.horna[i].t.x = akt_valec_stav.t_posun.x + akt_valec_stav.t_mierka.x*stav.kontura.v[i].t.x;
		//	akt_valec.horna[i].t.y = stav.t_posun.y;
		}

	//	if(prisposob_sirku && hrubka!=akt_valec_stav.hrubka)
	//		VypocitajNormaloveVektory( akt_valec);
	//	else
			for(int i=0; i<akt_valec.poc_bodov; i++)
				akt_valec.horna[i].n = mat.mul(nt,stav.kontura.v[i].n);

		nedokonceny_valec = false;
	//	valce.push_back( akt_valec);
		valce.add(akt_valec);
	}
	public void VypocitajNormaloveVektory()
	{
		v fn[];
		if(valce.size()<1)return;
		int faces = 2*(valce(0).poc_bodov-1);
	//	int bottom0,top0;			// nastavy sa na 1 ak ma zaciatok alebo koniec priemer 0
		fn = new v[ faces ];
		
		for(int i=0; i<valce.size(); i++)
		{
			// 0   1   2   3   4
			// +---+---+---+---+
			// |\  |\  |\  |\  |\
			// |0\1|2\3|4\5|6\7|8\9
			// |  \|  \|  \|  \|  \
			// +---+---+---+---+---+
			// 0   1   2   3   4   5
		//	if( Distance( valce(i).dolna[0].v, valce(i).dolna[1].v) < 0.0000001f)bottom0=1; else bottom0=0;
		//	if( Distance( valce(i).horna[0].v, valce(i).horna[1].v) < 0.0000001f)top0=1; else top0=0;
		//	if( bottom0 || top0) continue;

			for(int j=0; j<faces; j+=2)
			//	fn[j] = MakeNormal( valce(i).dolna[j/2].v, valce(i).dolna[j/2+1].v, valce(i).horna[j/2].v);
				fn[j] = v.MakeNormal( valce(i).dolna[j/2].ve, valce(i).horna[j/2].ve, valce(i).dolna[j/2+1].ve);
			for(int j=1; j<faces; j+=2)
			//	fn[j] = MakeNormal( valce(i).dolna[j/2+1].v, valce(i).horna[j/2+1].v, valce(i).horna[j/2].v);
				fn[j] = v.MakeNormal( valce(i).dolna[j/2+1].ve, valce(i).horna[j/2].ve, valce(i).horna[j/2+1].ve);

			if(valce(i).obojstranne_osvetlenie)
			{
				valce(i).dolna[0].n = fn[0];

				valce(i).dolna[valce(i).poc_bodov-1].n = v.add(fn[faces-2] , fn[faces-1]);
				valce(i).dolna[valce(i).poc_bodov-1].n.mul(0.5f);
			}
			else
			{
				valce(i).dolna[0].n = v.add(fn[0] , v.add(fn[faces-1] , fn[faces-2]));
				valce(i).dolna[0].n.mul(0.333333333333333333333333333333333f);

				valce(i).dolna[valce(i).poc_bodov-1].n = v.add(fn[faces-2] , v.add( fn[faces-1] , fn[0]));
				valce(i).dolna[valce(i).poc_bodov-1].n.mul(0.333333333333333333333333333333333f);
			}
			for(int j=1; j<valce(i).poc_bodov-1; j++)
			{
				valce(i).dolna[j].n = v.add(fn[2*j-2] , v.add(fn[2*j-1] , fn[2*j]));
				valce(i).dolna[j].n.mul(0.333333333333333333333333333333333f);
			}

		/*	valce(i).horna[0].n = fn[faces-1] + fn[0] + fn[1];
			valce(i).horna[0].n *= 0.333333333333333333333333333333333f;
			for( j=1; j<valce(i).poc_bodov-1; j++)
			{
				valce(i).horna[j].n = fn[2*j-1] + fn[2*j] + fn[2*j+1];
				valce(i).horna[j].n *= 0.333333333333333333333333333333333f;
			}
			valce(i).horna[valce(i).poc_bodov-1].n = fn[faces-1] + fn[0] + fn[1];
			valce(i).horna[valce(i).poc_bodov-1].n *= 0.333333333333333333333333333333333f;
		*/
			for(int j=0; j<valce(i).poc_bodov; j++)
				valce(i).horna[j].n = valce(i).dolna[j].n;

		}
	}

	public void VypocitajNormaloveVektory(z_valec a)
	{
		v fn[];
		int faces = 2*(a.poc_bodov-1);
		fn = new v[ faces ];

		// 0   1   2   3   4
		// +---+---+---+---+
		// |\  |\  |\  |\  |\
		// |0\1|2\3|4\5|6\7|8\9
		// |  \|  \|  \|  \|  \
		// +---+---+---+---+---+
		// 0   1   2   3   4   5

		for(int j=0; j<faces; j+=2)
		//	fn[j] = MakeNormal( a.dolna[j/2].v, a.dolna[j/2+1].v, a.horna[j/2].v);
			fn[j] = v.MakeNormal( a.dolna[j/2].ve, a.horna[j/2].ve, a.dolna[j/2+1].ve);
		for(int j=1; j<faces; j+=2)
		//	fn[j] = MakeNormal( a.dolna[j/2+1].v, a.horna[j/2+1].v, a.horna[j/2].v);
			fn[j] = v.MakeNormal( a.dolna[j/2+1].ve, a.horna[j/2].ve, a.horna[j/2+1].ve);

		if(a.obojstranne_osvetlenie)
		{
			a.dolna[0].n = fn[0];

			a.dolna[a.poc_bodov-1].n = v.add(fn[faces-2] , fn[faces-1]);
			a.dolna[a.poc_bodov-1].n.mul(0.5f);
		}
		else
		{
			a.dolna[0].n = v.add(fn[0] , v.add(fn[faces-1] , fn[faces-2]));
			a.dolna[0].n.mul(0.333333333333333333333333333333333f);

			a.dolna[a.poc_bodov-1].n = v.add(fn[faces-2] , v.add(fn[faces-1] , fn[0]));
			a.dolna[a.poc_bodov-1].n.mul(0.333333333333333333333333333333333f);
		}

		for(int j=1; j<a.poc_bodov-1; j++)
		{
			a.dolna[j].n = v.add(fn[2*j-2] , v.add(fn[2*j-1] , fn[2*j]));
			a.dolna[j].n.mul(0.333333333333333333333333333333333f);
		}

	/*	a.horna[0].n = fn[faces-1] + fn[0] + fn[1];
		a.horna[0].n *= 0.333333333333333333333333333333333f;
		for( j=1; j<a.poc_bodov-1; j++)
		{
			a.horna[j].n = fn[2*j-1] + fn[2*j] + fn[2*j+1];
			a.horna[j].n *= 0.333333333333333333333333333333333f;
		}
		a.horna[a.poc_bodov-1].n = fn[faces-1] + fn[0] + fn[1];
		a.horna[a.poc_bodov-1].n *= 0.333333333333333333333333333333333f;
	*/
		for(int j=0; j<a.poc_bodov; j++)
			a.horna[j].n = a.dolna[j].n;
	}
}
